.586
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include \masm32\include\windows.inc                         
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\shell32.inc
include \masm32\include\comdlg32.inc
include \masm32\include\gdi32.inc
include \masm32\include\advapi32.inc
include \masm32\include\comctl32.inc
include \masm32\include\masm32.inc

includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\shell32.lib
includelib \masm32\lib\comdlg32.lib
includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\advapi32.lib
includelib \masm32\lib\comctl32.lib
includelib \masm32\lib\masm32.lib

DlgProc		PROTO	:HWND,:UINT,:WPARAM,:LPARAM
InsertColumns   PROTO
AddLine		PROTO   :DWORD,:DWORD,:DWORD

include \masm32\macros\macros.asm

S macro	pdata:VARARG 
	LOCAL Buff
.data
	ifidni <pdata>,<>            
		Buff db 0        
	else            
		Buff db pdata,0
	endif
.code
	exitm <OFFSET Buff>
endm

.const
	IDD_DIALOG	equ 1000
	IDB_EXIT        equ 1001
	IDB_INSERT      equ 1003
	IDC_LIST        equ 1004

.data
	ListCap1	db "Cap1",0
	ListCap2	db "Cap2",0
	ListCap3	db "Cap3",0

	templateDH	db "%d",0
	templateByte	db "%s",0
	brw		dd 0

	sz1		db "text1",0
	sz2		db "text2",0
	sz3		db "text3",0
	buffer1		db 512 dup (0)

.data?
	hInstance	dd ?
	hList		dd ?
	lvi		LV_ITEM <>
	Buffer		db MAX_PATH dup(?)
	CancelLineColorNum	dd ?
	SetLineColorNum	dd ?

.code

CreateButton proc hParent:DWORD,lpText:DWORD,x:DWORD,y:DWORD,w:DWORD,h:DWORD,ID:DWORD
	LOCAL hFont :DWORD

	invoke  CreateFont,14,0,0,0,FW_NORMAL,FALSE,FALSE,FALSE, \
		    ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS, \
		    DEFAULT_QUALITY,DEFAULT_PITCH, S("Arial")
	mov	hFont, eax
	
	invoke	CreateWindowEx,0,S('BUTTON'),lpText,WS_CHILD or WS_VISIBLE ,
			x,y,w,h,hParent,ID,
			hInstance,NULL
	push	eax
	invoke	SendMessage,eax,WM_SETFONT,hFont, 0
	pop	eax
	ret

CreateButton endp

CreateListView proc hParent:DWORD, x:DWORD,y:DWORD,w:DWORD,h:DWORD,ID:DWORD
	LOCAL hFont :DWORD

	invoke  CreateFont,15,0,0,0,FW_NORMAL,FALSE,FALSE,FALSE, \
		    ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS, \
		    DEFAULT_QUALITY,DEFAULT_PITCH, S("Arial")
	mov	hFont, eax

	invoke	CreateWindowEx, WS_EX_STATICEDGE + WS_EX_TRANSPARENT,\
		S("SysListView32"),S("test"),WS_TABSTOP + WS_VSCROLL + CBS_SIMPLE+WS_VISIBLE+WS_CHILD,x,y,w,h,\
		hParent,ID,hInstance,NULL
	push	eax
	invoke	SendMessage,eax,WM_SETFONT,hFont, 0
	pop	eax
	ret

CreateListView endp

DlgProc proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL QueryStr:DWORD
	
	.if uMsg == WM_CREATE
		invoke	CreateButton,hWnd,S('INSERT'),71,256,56,20,IDB_INSERT
		invoke	CreateButton,hWnd,S('EXIT'),7,256,56,20,IDB_EXIT
		invoke	CreateListView,hWnd,7,16,398,229,IDC_LIST
		mov	hList,eax
		invoke	SendMessage,hList,LVM_SETEXTENDEDLISTVIEWSTYLE,LVS_EX_FULLROWSELECT or LVS_EX_HEADERDRAGDROP,-1
		
		invoke	InsertColumns
		invoke	AddLine,addr sz1,addr sz2,addr sz3
		invoke	AddLine,addr sz1,addr sz2,addr sz3
   
		invoke	AddLine,addr sz1,addr sz2,addr sz3
		invoke	AddLine,addr sz1,addr sz2,addr sz3
		invoke	AddLine,addr sz1,addr sz2,addr sz3
		invoke	AddLine,addr sz1,addr sz2,addr sz3
		invoke	AddLine,addr sz1,addr sz2,addr sz3
		mov	SetLineColorNum,-1
   
	.elseif uMsg == WM_COMMAND
		.if wParam == IDB_EXIT
			invoke	DestroyWindow, hWnd
		.elseif wParam==IDB_INSERT
			invoke AddLine,addr sz1,addr sz2,addr sz3
		.endif
	.elseif uMsg == WM_NOTIFY
		push	edi
		mov	edi,lParam
		mov	eax, [edi.NMHDR].hwndFrom
		.if	eax == hList
			.if [edi.NMHDR].code == NM_RDBLCLK	;Set Color on focus
				invoke	SendMessage,hList,LVM_GETNEXTITEM,-1,LVNI_FOCUSED
				mov	CancelLineColorNum,eax
			.elseif [edi.NMHDR].code == NM_DBLCLK	;Remove Color on focus
				invoke	SendMessage,hList,LVM_GETNEXTITEM,-1,LVNI_FOCUSED
				mov	SetLineColorNum,eax
			.endif
		.endif
		
		mov	edi,lParam
		assume	edi:ptr NMLVCUSTOMDRAW
		mov	eax,[edi].nmcd.hdr.code
		.if	eax== NM_CUSTOMDRAW
			mov	eax,[edi].nmcd.dwDrawStage
			.if	eax==CDDS_PREPAINT
				mov eax,CDRF_NOTIFYITEMDRAW
				ret
			.elseif eax==CDDS_ITEMPREPAINT
				mov [edi].clrTextBk,096DAFDH;eax
				mov [edi].clrText,0FF0000h
				mov eax,CDRF_NOTIFYSUBITEMDRAW
				ret
			.elseif eax==CDDS_SUBITEM or CDDS_ITEMPREPAINT
				mov	ebx,SetLineColorNum
				mov	ecx,CancelLineColorNum
				.if	[edi].nmcd.dwItemSpec==ebx
					mov [edi].clrTextBk,044BCFCh
				.elseif [edi].nmcd.dwItemSpec==ecx
					mov [edi].clrTextBk,096DAFDH
				.endif
				mov	SetLineColorNum,-1
				mov	CancelLineColorNum,-1
			.endif
			mov eax,CDRF_NEWFONT
			ret
		.endif
		ASSUME edi:nothing           
		pop	edi
	.elseif uMsg == WM_CLOSE
		invoke	DestroyWindow, hWnd
	.elseif uMsg == WM_DESTROY
		invoke	PostQuitMessage, NULL
	.else
		invoke	DefWindowProc, hWnd, uMsg, wParam, lParam
		ret
	.endif
ret0:
         xor    eax, eax
         ret
DlgProc endp

InsertColumns proc
	LOCAL lvc:LV_COLUMN

	invoke SendMessage,hList,LVM_SETEXTENDEDLISTVIEWSTYLE,LVS_EX_FULLROWSELECT or LVS_EX_FLATSB ,-1
	mov lvc.imask,LVCF_TEXT+LVCF_WIDTH
	mov lvc.pszText,offset ListCap1
	mov lvc.lx,100
	invoke SendMessage,hList, LVM_INSERTCOLUMN,0,addr lvc
	or lvc.imask,LVCF_FMT
	mov lvc.fmt,LVCFMT_LEFT ;CENTER
	mov lvc.pszText,offset ListCap2
	mov lvc.lx,130
	invoke SendMessage,hList, LVM_INSERTCOLUMN, 1 ,addr lvc
	mov lvc.pszText,offset ListCap3
	mov lvc.lx,120
	invoke SendMessage,hList, LVM_INSERTCOLUMN, 2 ,addr lvc
	
	ret
InsertColumns endp

AddLine PROC Location:DWORD,Byte1:DWORD,Byte2:DWORD

	invoke	lstrcpy,addr Buffer,Location
	mov	lvi.imask,LVIF_TEXT
	mov	lvi.pszText,offset Buffer
	mov	lvi.iSubItem,0
	invoke	SendMessage,hList,LVM_INSERTITEM,0,addr lvi
	mov	lvi.iItem,eax
	inc	lvi.iSubItem
	invoke	lstrcpy,addr Buffer,Byte1
	invoke	SendMessage,hList,LVM_SETITEM,0,addr lvi
	inc	lvi.iSubItem
	invoke	lstrcpy,addr Buffer,Byte2
	invoke	SendMessage,hList,LVM_SETITEM,0,addr lvi
	ret 
	
AddLine ENDP

TopXY proc wDim:DWORD, sDim:DWORD

	shr sDim, 1      
	shr wDim, 1      
	mov eax, wDim    
	sub sDim, eax    

	mov eax, sDim
	ret

TopXY endp

WinMain proc hInst:DWORD, hPrevInst, CmdLine, CmdShow
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	LOCAL Wwd:DWORD
	LOCAL Wht:DWORD
	LOCAL Wtx:DWORD
	LOCAL Wty:DWORD
	LOCAL hWnd:HANDLE
	LOCAL hFont :DWORD

	invoke  CreateFont,14,0,0,0,FW_NORMAL,FALSE,FALSE,FALSE, \
		    ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS, \
		    DEFAULT_QUALITY,DEFAULT_PITCH, S("Arial")
	mov	hFont, eax

        mov	wc.cbSize, sizeof WNDCLASSEX
        mov	wc.style, CS_BYTEALIGNCLIENT or CS_BYTEALIGNWINDOW
        mov	wc.lpfnWndProc, offset DlgProc
        mov	wc.cbClsExtra, NULL
        mov	wc.cbWndExtra, NULL
        m2m	wc.hInstance,hInst
        mov	wc.hbrBackground, COLOR_BTNFACE+1
        mov	wc.lpszClassName, S("EnumWindow")
	invoke	LoadIcon, NULL, IDI_APPLICATION
        mov	wc.hIcon, eax
        mov	wc.hIconSm, eax
	invoke	LoadCursor, NULL, IDC_ARROW
        mov	wc.hCursor, eax

	invoke	RegisterClassEx, addr wc
	mov	Wwd, 425
	mov	Wht, 305

	invoke	GetSystemMetrics,SM_CXSCREEN
	invoke	TopXY,Wwd,eax
	mov	Wtx, eax

	invoke	GetSystemMetrics,SM_CYSCREEN
	invoke	TopXY,Wht,eax
	mov	Wty, eax

	invoke	CreateWindowEx, NULL, S("EnumWindow"),\
			S("test_list"), WS_OVERLAPPEDWINDOW,\
			Wtx,Wty,Wwd,Wht,NULL, NULL, hInst, NULL
        mov	hWnd, eax

	invoke	ShowWindow, hWnd, SW_SHOWNORMAL
	invoke	UpdateWindow, hWnd
	invoke	SendMessage,hWnd,WM_SETFONT,hFont, 0

	.while TRUE
		invoke GetMessage, addr msg, NULL, 0, 0
		.break .if (!eax)
		invoke TranslateMessage, addr msg
		invoke DispatchMessage, addr msg
	.endw
        mov eax, msg.wParam
        ret
WinMain endp

start:
	invoke	GetModuleHandle,NULL
	mov	hInstance,eax
	invoke	InitCommonControls
	invoke	GetCommandLine
	invoke	WinMain, hInstance ,NULL, eax, SW_SHOWDEFAULT
	invoke	ExitProcess,0


end start

